
package dom;
import java.io.*;
import java.util.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.w3c.dom.traversal.*;
import java.nio.charset.*;
import org.xml.sax.*;

public class KnihovnaDom {

    
    public static void main(String[] args) {
//String [] args={"in","data.xml","out","nova.xml"};
        if(args.length==4){
            doSouboru(args);
        }else if(args.length==2){
              bezSouboru(args);
        }else{
      
        }
    }
    
    public static void doSouboru(String [] args){
        try {
            
               DocumentBuilderFactory aaa = DocumentBuilderFactory.newInstance();
              DocumentBuilder docbuilder = aaa.newDocumentBuilder();
            aaa.setValidating(false);

            docbuilder.setErrorHandler(new ErrorVypis(true));
            Document doc = docbuilder.parse(args[1]); //nacte soubor do pameti
            deleteWhiteSpaces(doc);
          zmenDokument(doc);
            zmenDatumNar(doc);
            
            TransformerFactory menic=TransformerFactory.newInstance();
            Transformer bbb=menic.newTransformer();
            bbb.setOutputProperty(OutputKeys.ENCODING, "iso-8859-2");//kodovani vysledneho souboru
            bbb.setOutputProperty(OutputKeys.INDENT, "yes");//odsazeni textu pro starsi javu nez 1.6
            bbb.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2"); //odsazeni textu
            
            
            bbb.transform(new DOMSource(doc), new StreamResult(new File(args[3])));
        } catch (Exception e) {
            try{
                BufferedWriter bb=new BufferedWriter(new FileWriter(new File(args[3])));
                bb.write("ERROR: "+e.toString());
                bb.close();
                System.exit(1);
            } catch(Exception v){
                System.err.println(v.toString());
            }
        }
        
        
        
    }
    public static void bezSouboru(String [] args){
        try {       
            DocumentBuilderFactory aaa = DocumentBuilderFactory.newInstance();
              DocumentBuilder docbuilder = aaa.newDocumentBuilder();
            aaa.setValidating(false);
         
            docbuilder.setErrorHandler(new ErrorVypis(true));
            Document doc = docbuilder.parse(args[1]); //nacte soubor do pameti
            deleteWhiteSpaces(doc);
            zmenDokument(doc);
            zmenDatumNar(doc);
            
            TransformerFactory menic=TransformerFactory.newInstance();
            Transformer bbb=menic.newTransformer();
            bbb.setOutputProperty(OutputKeys.ENCODING, "iso-8859-2");//kodovani vysledneho souboru
            bbb.setOutputProperty(OutputKeys.INDENT, "yes");//odsazeni textu pro starsi javu nez 1.6
            bbb.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2"); //odsazeni textu
            
            bbb.transform(new DOMSource(doc), new StreamResult(new File(args[1])));
        } catch (Exception e) {
         System.err.println("ERROR: "+e.toString());       
        }
        
    }
    public static void zmenDokument(Document doc){
        // odstarni vypujcky a podelementy
        // najdi uzel
        Node knihovna = doc.getDocumentElement();
       
        NodeList seznam=doc.getElementsByTagName("seznam_vypujcek");
        Node singl=seznam.item(0);
       
        NodeList nl=doc.getElementsByTagName("vypujcka"); // <vypujcky>
        boolean odstranen=false;
   
        for(int index=0;index<nl.getLength();index++){
            if(!odstranen){
                Node datumy=nl.item(index);// 1. <vypujcky>
                // 1. <vypujcka>
                NodeList r=datumy.getChildNodes();
    
                Node c=r.item(1);
 
                NodeList dd=c.getChildNodes();
                Node d=dd.item(2);
           try{
                if(Integer.valueOf(d.getTextContent())<2007){// odstrani stare vypujcky
                    singl.removeChild(datumy);
                    
                    index--;
                }
            }catch(NullPointerException vv){
                
                
            }}
        }
    }
    
    public static void zmenDatumNar(Document doc){
//zmenit datum narozeni ctenare Peter Novak s ctenar_id c2 na 11.11.1111
        Node knihovna = doc.getDocumentElement();
  
        NodeList seznam=doc.getElementsByTagName("seznam_ctenaru");
        Node singl=seznam.item(0);
  
        NodeList nl=doc.getElementsByTagName("ctenar"); // <vypujcky>
        boolean odstranen=false;
        for(int index=0;index<nl.getLength();index++){
            
            Node datumy=nl.item(index);// 1. <ctenar>
         
            NamedNodeMap map=datumy.getAttributes();
            String atribut=map.getNamedItem("ctenar_id").getNodeValue();
            if(atribut.equals("c2")){
         
                
                NodeList r=datumy.getChildNodes();
                Node a=r.item(0);
         
                Node b=r.item(1);
             
                Node c=r.item(3);// prijmeni, 1 je jmeno
               
                Node d=r.item(2);//datum nar
       
                NodeList data=d.getChildNodes();
                NodeList den_tag=data.item(0).getChildNodes();
                Node den=den_tag.item(0);
                den.setNodeValue("11");
             
                NodeList mesice=data.item(1).getChildNodes();
                Node mesic=mesice.item(0);
                mesic.setNodeValue("11");
         
                NodeList rok_tag=data.item(2).getChildNodes();
                Node rok=rok_tag.item(0);
                rok.setNodeValue("1111");
             
            }
        }
    }
    public static void deleteWhiteSpaces(Document doc) {
        Node n = doc.getDocumentElement();
        NodeIterator ni = ((DocumentTraversal)doc).createNodeIterator(doc.getDocumentElement(), NodeFilter.SHOW_TEXT, new PrazdnyText(), false);
        while ((n = ni.nextNode()) != null) {
            Node rodic = n.getParentNode();
            rodic.removeChild(n);
        }
    }
    
}
class PrazdnyText implements NodeFilter {
    public short acceptNode(Node n) {
        if (n.getNodeValue().trim().length() == 0) {
            return NodeFilter.FILTER_ACCEPT;
        } else {
            return NodeFilter.FILTER_SKIP;
        }
    }
}



class ErrorVypis implements ErrorHandler {
    public BufferedWriter bw;
    public boolean doSouboru=false;
    public ErrorVypis(boolean a){
        this.doSouboru=a;
        
        
    }
    public ErrorVypis(boolean a, BufferedWriter b){
        this.doSouboru=a;
        this.bw=b;
        
    }
    public void warning(SAXParseException e) {
        if(doSouboru){
            try{
                bw.write("ERROR: "+e.toString());
                bw.newLine();} catch(Exception aa){
                    System.err.println("ERROR: "+" Nelze zapsat do souboru "+aa.toString());
                }
        }else{
            System.err.print("ERROR: "+e.toString());}
        
    }
    
    public void fatalError(SAXParseException e) throws SAXException {
        throw new SAXException("ERROR: "+e.toString());
    }
    
    public void error(SAXParseException e) throws SAXException {
        throw new SAXException("ERROR: "+e.toString());
    }  
}